package com.eactive.eai.batch.job.jobItem.debit;

import java.io.ByteArrayOutputStream;
import java.util.Properties;

import com.eactive.eai.batch.job.jobConstant.TelegramKeys;
import com.eactive.eai.batch.job.jobItem.DefaultTelegram;
import com.eactive.eai.batch.job.jobItem.TelegramService;

import com.eactive.eai.common.exception.ExceptionUtil;

public class SEND_DEBIT_0600 extends DefaultTelegram implements TelegramService {

    private int SEND_LENGTH;       //TCP/IP전문 송신 BYTES수로 "업무구분코드"이후의 송신할 전문 길이
    private int REAL_SEND_LENGTH;  //실제 송신할 전문의 총길이

    //>> 업무관리정보
    private final String OpCode_start          = "001";    //개별 업무 개시
    //private final String OpCode_resume         = "002";    //파일 송수신 계속
    private final String OpCode_unit_end       = "003";    //개별업무 종료
    private final String OpCode_all_end        = "004";    //개별업무 종료

    private Properties telegramInfo;

    /**
     * 생성자
     */
    public SEND_DEBIT_0600() {
        //업무개시요구 및 업무개시통보
    }

    /**
     * 전문조립
     */
    public boolean doExecute() {
        try {
            boolean result = calculateSendLength();
            if (!result) return false;

            //전문송신 Byte 수 : EAI에서 정의
            compileField(0, ""+SEND_LENGTH, this.al_FieldProps[0]);

            //업무구분코드 - FTP
            compileField(1, telegramInfo.getProperty(TelegramKeys.BIZ_GBN), this.al_FieldProps[1]);

            //은행코드
            compileField(2, telegramInfo.getProperty(TelegramKeys.BANK_CODE), this.al_FieldProps[2]);

            //전문종별코드.
            compileField(3, this.getFldTelegramType(), this.al_FieldProps[3]);

            //거래구분코드
            String bizGubunCode = null;
            if ( this.getFldOpCode().equals(OpCode_start)){
                bizGubunCode = batchDoc.getBatchMsg().getHeader().getBizCode().subSequence(0,4) + "00";
            }else{
                bizGubunCode = batchDoc.getBatchMsg().getHeader().getBizCode();
            }
            compileField(4, bizGubunCode, this.al_FieldProps[4]);

            //송수신 FLAG : 전문 발생 기관을 구분하여  아래의 값을 SET한다.
            //             C  : VAN사 송신,  B  : 은행 송신
            compileField(5, telegramInfo.getProperty(TelegramKeys.TRA_FLAG_BANK), this.al_FieldProps[5]);

            //응답코드  0 과 VAN구분 코
            compileField(6, this.getResolveResponseCode(), this.al_FieldProps[6]);
            // 여기 까지 공통부

            //송수신 업무 구분코드.
            compileField(7, getFldTrClass() , this.al_FieldProps[7]);


            //전문 전송일시 MMDDHHMMSS     전문을 발신하는 기관에서 전문을 전송하는 일자와 시간을 SET 한다.
            compileField(8, TelegramKeys.getMMddHHmmss(), this.al_FieldProps[8]);

            //업무 관리 정보 - 파일전송업무 관리를 위한 정보로 아래의 값 중 하나를 Set 한다.
            // “001”: 개별 업무 개시 “002”: 파일 송수신 계속
            // “003”: 개별 업무 종료 “004”: 전업무종료 요구/요구응답
            compileField(9, this.getFldOpCode(), this.al_FieldProps[9]);

            //송신자명 파일전송업무의 책임이 있는 사람의 나타내는 ID를 Set한다.
            compileField(10, batchDoc.getBatchMsg().getHeader().getUserID(), this.al_FieldProps[10]);

            //송신자 암호 (정당한 송신자 확인을 위한 쌍방간 합의된 암호
            compileField(11, batchDoc.getBatchMsg().getHeader().getUserPassword(), this.al_FieldProps[11]);

            //송신 집계 내역
            boolean skip_sum = false;
            try {
				if ( telegramInfo.getProperty(TelegramKeys.SKIP_SUMMARY).indexOf("Y") > -1 ){
					skip_sum = true;
				}
			} catch (Exception e) {}
			
			if ( skip_sum ){
                compileField(12, makeZero("", this.al_Field.get(12).length), this.al_FieldProps[12]);
			}else{
	            if ( OpCode_unit_end.equals(getFldOpCode())) {
	                compileField(12, batchDoc.getBatchMsg().getBody().getSendSummary(), this.al_FieldProps[12]);
	            }else if ( OpCode_all_end.equals(getFldOpCode())){
	                logger.debug("[SEND_DEBIT_0600]batchDoc.getBatchMsg().getHeader().getBizCode()-->" + batchDoc.getBatchMsg().getHeader().getBizCode());
	                logger.debug("[SEND_DEBIT_0600]batchDoc.getBatchMsg().getBody().getSendSummary()-->" + batchDoc.getBatchMsg().getBody().getSendSummary());
	                compileField(12, "01" + batchDoc.getBatchMsg().getHeader().getBizCode().substring(0, 2)+ "00" + batchDoc.getBatchMsg().getBody().getSendSummary().substring(0,2), this.al_FieldProps[12]);
	            }else{
	                compileField(12, "", this.al_FieldProps[12]);
	            }
			}

            //<< 전문 완성

            return true;
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI001";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
    }

    /**
     * 실제 송신할 전문의 총길이를 리턴해준다.
     */
    public int getSendLength()
    {
        try {
            return REAL_SEND_LENGTH;  //실 DATA BYTE수
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI013";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    public boolean doPreExecute() {
        try {
            if (!super.doPreExecute()) return false;
            telegramInfo = getTelegramInfo();
            try {
				int sleepTime = Integer.parseInt(telegramInfo.getProperty(TelegramKeys.SLEEP_TIME));
				Thread.sleep(sleepTime); 
			} catch (Exception e) {}
            return true;
        } catch (Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI003";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    public boolean doPostExecute() {
        if (!super.doPostExecute()) return false;

        try {
            //DB로그에 남길 전문 헤더 설정
            ByteArrayOutputStream baout = new ByteArrayOutputStream();
            for (int i=0; i<7; i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramHeader(new String(baout.toByteArray()));

            //DB로그에 남길 전문 바디 설정
            baout = new ByteArrayOutputStream();
            for (int i=7; i< al_Field.size(); i++) {
                baout.write((byte[])this.al_Field.get(i));
            }
            batchDoc.getBatchMsg().setTelegramBody(new String(baout.toByteArray()));

            return true;

        } catch(Exception ex) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI002";
            String errMsg = ExceptionUtil.getErrorCode (ex, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( ex.getMessage(), ex);
            return false;
        }
    }

    private boolean calculateSendLength () {
        try {
            // 맨 마지막 XX 필드는 수신 버퍼 처리용이므로 보내는 경우에는 계산하지 않음 2009.09.10 dhjeong
            for (int i=1; i< this.al_Field.size() - 1; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                SEND_LENGTH += aField.length;
            }
            SEND_LENGTH += getCalculatedLength(this.al_Field.size() - 1);
            REAL_SEND_LENGTH = SEND_LENGTH;
            for (int i=0; i < 1 ; i++) {
                byte[] aField = (byte[]) this.al_Field.get(i);
                REAL_SEND_LENGTH += aField.length;
            }
        } catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI025";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return false;
        }
        return true;
    }

    public int getInformalFieldSendData(int idx, byte[] data) {
    	int dLen = getCalculatedLength(idx);
    	if (dLen > 0) {
    		for (int inx = 0; inx < data.length; inx++) {
				data[inx] = ' ';
			}
    		return dLen;
    	}else{
            return 0;
    	}
    }

    /**
     * 비정형 필드에 대한 송신 길이를 계산해서 리턴해준다.
     *
     * 필드(idx)가 비정형 필드(XX)인지 점검하고 , 해당 필드에 대한 예상 길이를 계산하여 리턴하도록 한다
     *
     * 비정형 필드를 가지고 있는 개별 Telegram Class 에서 오버라이드 필요.
     */
    public int getCalculatedLength(int idx) {
        try {
            if (idx >= this.getFieldCount() ) {
                logger.debug("{} getCalculatedLength> parameter is bigger than field count", logHeader);
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI011";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
            if (this.getFieldLength(idx).equalsIgnoreCase(TelegramService.FIELD_NO_LENGTH)) {
                try {
                	return Integer.parseInt(getTelegramInfo().getProperty(TelegramKeys.FILLER_LEN_0600));
				} catch (Exception e) {
	            	return 0;
				}
            } else {
                String[] msgArgs = new String[2];
                msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
                msgArgs[1] = ""+idx;
                String errCode = "BECEAIFJI012";
                String errMsg = ExceptionUtil.getErrorCode (errCode, msgArgs);
                this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
                return -1;
            }
        }catch (Exception e) {
            String[] msgArgs = new String[1];
            msgArgs[0] = this.batchDoc.getBatchMsg().getHeader().getProcessCode();
            String errCode = "BECEAIFJI005";
            String errMsg = ExceptionUtil.getErrorCode (e, errCode, msgArgs);
            this.batchDoc.getBatchMsg().getBody().setErrorMsg(errMsg);
            logger.error( e.getMessage(), e);
            return -1;
        }
    }

    //---------------- 특정 필드값을 구하는 부분
    // 전문종별코드 필드값 리턴
    public String getTelegramType()
    {
        return super.getFieldValueString(3);
    }
    // 거래구분코드 필드값 리턴
    public String getTrClass()
    {
        return super.getFieldValueString(7);
    }
    //응답코드 필드값 리턴
    public String getResCode()
    {
        return super.getFieldValueString(6);
    }
    //업무관리코드 필드값 리턴
    public String getOpCode()
    {
        return super.getFieldValueString(9);
    }
}